<?php

/*
 * Plugin: Hello World
 * ~~~~~~~~~~~~~~~~~~~
 * INCLUDE DESCRIPTION HERE
 *
 * ----------------------------------------------------------------------------------
 * Author:		AUTHOR
 * Version:		VERSION
 * Date:		DATE
 * Copyright:		2012 by AUTHOR
 * System:		XAseco2/1.00+
 * Game:		ManiaPlanet Trackmania2 (TM2)
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 *
 * Dependencies:
 *  - none
 */

Aseco::registerEvent('onSync',				'hewo_onSync');
Aseco::registerEvent('onPlayerConnect',			'hewo_onPlayerConnect');
Aseco::registerEvent('onPlayerDisconnect',		'hewo_onPlayerDisconnect');

// See also http://labs.undef.de/Development/Events.php#EventlistXAseco2


/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function hewo_onSync ($aseco) {

	// Check for the right XAseco2-Version
	$xaseco2_min_version = '1.00';
	if ( defined('XASECO2_VERSION') ) {
		if ( version_compare(XASECO2_VERSION, $xaseco2_min_version, '<') ) {
			trigger_error('[plugin.hello_world.php] Not supported XAseco2 version ('. XASECO2_VERSION .')! Please update to min. version '. $xaseco2_min_version .'!', E_USER_ERROR);
		}
	}
	else {
		trigger_error('[plugin.hello_world.php] Can not identify the System, "XASECO2_VERSION" is unset! This plugin runs only with XAseco2/'. $xaseco2_min_version .'+', E_USER_ERROR);
	}

	// Make sure the Server is a MP one.
	if ($aseco->server->getGame() != 'MP') {
		trigger_error('[plugin.hello_world.php] This plugin supports only TM2 (ManiaPlanet), can not start with a "'. $aseco->server->getGame() .'" Dedicated-Server!', E_USER_ERROR);
	}

}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function hewo_onPlayerConnect ($aseco, $player) {

	// Build the "Hello World" message and include the Nickname of the connecting Player
	$message = 'Hello '. stripColors($player->nickname) .'! This is just a {#highlite}Hello World{#server} message for you. ;)';

	// The function stripColors() from "includes/basic.inc.php" removes
	// all Colors/Formats/Links from the Nickname from the connecting Player.
	//
	// The "{#highlite}" and "{#server}" are changed from "$aseco->formatColors()" below
	// to "$fff" and "$ff0", see "config.xml" <colors> for more


	// Send the $message to the connecting Player
	$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $player->login);

	// 'ChatSendServerMessageToLogin' takes two parameters: Message and Login(s)
	// See also http://www.gamers.org/tmf/docs/ListMethods.html


	// The $player object includes many more information about the Player. If you want to see this,
	// you can uncomment this line and all details will be stored into the xaseco.log
	//$aseco->console( var_dump($player) );

}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function hewo_onPlayerDisconnect ($aseco, $player) {

	// Build the "Bye bye" message and include the Nickname of the disconnecting Player
	$message = 'The Player '. stripColors($player->nickname) .' just leaved this Server!';

	// Send the $message to all connected Players
	$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));

	// 'ChatSendServerMessage' takes one parameter: Message
	// See also http://www.gamers.org/tmf/docs/ListMethods.html
}

?>
